#include "stdafx.h"
#include "Graphic.h"

LPDIRECT3D9				g_pD3D = NULL;			//D3DC^[tF[X D3DfoCX̂ɕKv
LPDIRECT3DDEVICE9		g_pD3DDevice = NULL;	//D3DfoCX `ȂǍL͈͂ŕKvɂȂB

LGraphicDisplayMode		g_currDisplayMode;				//ʃ[h
DWORD					g_backColor = 0xFFFFFFFF;		//wiF

//̃R[h쐬ꂽD3DfoCX擾邽߂̂
LPDIRECT3DDEVICE9 GetDevice()
{
	return g_pD3DDevice;
}

//Direct3D̏
bool LGraphic_Create(HWND hWnd, LGraphicDisplayMode mode )
{
	if ( g_pD3D ) {
		LGraphic_Release();
	}

	g_currDisplayMode = mode;

	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if ( g_pD3D == NULL ) {
		return false;
	}
	
	//D3DPRESENT_PARAMETERS\̏̂߃fBXvC[h擾
	D3DDISPLAYMODE dmode;
	ZeroMemory( &dmode, sizeof( dmode ) );
	g_pD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT , &dmode );
	
	//foCX̏Ԃw肷
	D3DPRESENT_PARAMETERS	d3dpp;
	ZeroMemory( &d3dpp, sizeof( d3dpp ) );

	switch ( mode ) {
		case LGraphicDisplayMode::FullScreen:
			//tXN[
			d3dpp.Windowed         = FALSE;
			d3dpp.BackBufferWidth  = 640;
			d3dpp.BackBufferHeight = 480;
			d3dpp.BackBufferFormat = D3DFMT_X8R8G8B8;
			d3dpp.BackBufferCount  = 1;
			d3dpp.SwapEffect       = D3DSWAPEFFECT_DISCARD;
			d3dpp.FullScreen_RefreshRateInHz = 60;
			break;
		case LGraphicDisplayMode::WindowMode:
			//EBhE[h
			d3dpp.Windowed			= TRUE;
			d3dpp.SwapEffect		= D3DSWAPEFFECT_DISCARD;
			d3dpp.BackBufferFormat	= dmode.Format;
			d3dpp.BackBufferCount	= 1;
			break;
	}
	
	//3D\̐ݒ Zobt@
	d3dpp.EnableAutoDepthStencil = true;
	d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	
	//fBXvCA_v^\߂̃foCX쐬
	//`揈@ƒ_@̓n[hEFAΉłƎŝŁA@̑gݍ킹ςčēx쐬݂
	HRESULT		hr;
	D3DDEVTYPE	devtype;
	DWORD		behaviorFlags;
	for ( int c = 0; c < 4; c++ ) {

		switch ( c ) {
            case 0:
				//n[hEFAŕ`揈s
				devtype			= D3DDEVTYPE_HAL;						
				//_n[hEFAōs
				behaviorFlags	= D3DCREATE_HARDWARE_VERTEXPROCESSING;
				break;
			case 1:
				//n[hEFAŕ`揈s
				devtype			= D3DDEVTYPE_HAL;
				//_\tgEFAōs
				behaviorFlags	= D3DCREATE_SOFTWARE_VERTEXPROCESSING;
				break;
			case 2:
				//\tgEFAŕ`揈s
				devtype			= D3DDEVTYPE_REF;
				//_n[hEFAōs
				behaviorFlags	= D3DCREATE_HARDWARE_VERTEXPROCESSING;
				break;
			case 3:
				//\tgEFAŕ`揈s
				devtype			= D3DDEVTYPE_REF;						
				//_\tgEFAōs
				behaviorFlags	= D3DCREATE_SOFTWARE_VERTEXPROCESSING;
				break;
		}
	
		hr = g_pD3D->CreateDevice(
						D3DADAPTER_DEFAULT,
						devtype,
						hWnd,
						behaviorFlags,
						&d3dpp,
						&g_pD3DDevice );
		
		
		if ( FAILED(hr) ) {
			continue;
		}
		break;
	}

	if ( FAILED(hr) ) {
		//\tgEFAɂΉĂȂ
		return false;
	}

	//At@uh̐ݒ
	g_pD3DDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
	//Lł͎vʂɓ߂Ȃ͂Ȃ̂ŁAufBOW̐ݒsB
	g_pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);	 
	g_pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA); 

	return true;
}

//Direct3D
void LGraphic_Release()
{
	//D3DfoCX
	if( g_pD3DDevice )
	{
		g_pD3DDevice->Release();
		g_pD3DDevice = NULL;
	}

	//D3DC^[tF[X
	if( g_pD3D )
	{
		g_pD3D->Release();
		g_pD3D = NULL;
	}
}

//`OɌĂ
void LGraphic_ClearAndBegin()
{
	//ʃNA
	GetDevice()->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, g_backColor, 1.0f, 0 );

	//foCXɕ`Jnm点
	HRESULT hr;
	hr = g_pD3DDevice->BeginScene();

}

//`ɌĂ
void LGraphic_EndAndPresent()
{
	//foCXɕ`Im点
	g_pD3DDevice->EndScene();
	
	//ʂobNobt@ƓւB
	g_pD3DDevice->Present( NULL, NULL, NULL, NULL );

}
