#include "stdafx.h"
#include "Graphic.h"

Shader::Shader()
{
	m_pVertexDeclaration = NULL;
	m_pEffect = NULL;

	m_WorldViewProjection = NULL;
	m_Texture = NULL;
	m_pass = 0;
}

//VF[_쐬iVF[_vOt@C̓ǂݍ݁j
bool Shader::Create( LPCWSTR path )
{
	if ( m_pEffect ) {
		Release();
	}
	
	try {

		HRESULT hr;

		D3DCAPS9 caps;
		GetDevice()->GetDeviceCaps(&caps);
		
		//_VF[_AsNZVF[_g邩
		if ( ( caps.VertexShaderVersion < D3DVS_VERSION(2,0) ) ||
			 ( caps.PixelShaderVersion < D3DPS_VERSION(2,0)  ) ) {
			::MessageBox(NULL,_T("p̃OtBbNX{[h̓vO}uVF[_ɑΉĂ܂B"),_T(""),MB_OK);
			throw 0;
		}

		//t@C̓ǂݍ
		LPD3DXBUFFER pErrMessage = NULL;
		hr = D3DXCreateEffectFromFile( GetDevice(), path, NULL, NULL, 0, NULL, &m_pEffect, &pErrMessage );
		if ( FAILED(hr) ) {
			//G[bZ[W̕R[hANSI
			::MessageBoxA(NULL,(LPCSTR)(pErrMessage->GetBufferPointer()),"",MB_OK);
			pErrMessage->Release();
			throw 0;
		}
		
		//pCvCɓn_f[^̍\`
		D3DVERTEXELEMENT9 decl[] = {
			{ 0, 0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },	//ʒu
			{ 0, 12, D3DDECLTYPE_D3DCOLOR, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR, 0},	//F
			{ 0, 16, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0},	//eNX`W
			D3DDECL_END() //ŌɕKD3DDECL_END()
		};

		hr = GetDevice()->CreateVertexDeclaration( decl, &m_pVertexDeclaration );
		if ( FAILED( hr) ) {
			throw 0;
		}
	
		//VF[_֒_`Zbg
		GetDevice()->SetVertexDeclaration( m_pVertexDeclaration );

		//VF[_gpeNjbNiVF[_vȎgݍ킹݂Ȃ́jw
		m_pEffect->SetTechnique("RenderScene");

		//VF[_vÕO[oϐnh擾Ă
		m_WorldViewProjection = m_pEffect->GetParameterByName( NULL, "g_mWorldViewProjection" );
		m_Texture = m_pEffect->GetParameterByName( NULL, "g_Texture" );

	} catch(...)
	{
		Release();
		return false;
	}

	return true;
}

void Shader::ChangePass( UINT pass )
{
	m_pass = pass;
}

//VF[_vOgpJn錾
//BeginEnd̊ԂɃ|S`悵܂
void Shader::Begin()
{
	//GtFNgJn
	m_pEffect->Begin( NULL, 0 );	//gƃpX̐擾ł
	
	//gppXI
	m_pEffect->BeginPass( m_pass );
}

//VF[_vOI̐錾
void Shader::End()
{
	m_pEffect->EndPass();	//pXI
	m_pEffect->End();		//GtFNgI
}

//VF[_Kp
void Shader::SetData( D3DXMATRIX* mat, LPDIRECT3DTEXTURE9 texture )
{
	//VF[_̃O[oϐփf[^Zbg
	m_pEffect->SetMatrix( m_WorldViewProjection, mat );
	m_pEffect->SetTexture( m_Texture, texture );

	//ȂӂɖOŒڃZbg邱Ƃł܂
	//m_pEffect->SetMatrix("g_mWorldViewProjection", mat );
	//m_pEffect->SetTexture( "g_Texture", texture );

}

//VF[_
void Shader::Release()
{
	if ( m_pEffect ) {
		m_pEffect->Release();
	}

	if ( m_pVertexDeclaration ) {
		m_pVertexDeclaration->Release();
	}

	m_WorldViewProjection = NULL;
	m_Texture = NULL;
	m_pass = 0;
}